package com.jiuqi.mde;

import java.util.ArrayList;

public class MDEDimValueSetCollection
{
    protected ArrayList dimValuesList;
    
    public MDEDimValueSetCollection() {
        this.dimValuesList = new ArrayList();
    }
    
    public MDEDimValueSetCollection(final int capacity) {
        this.dimValuesList = new ArrayList(capacity);
    }
    
    public final int size() {
        return this.dimValuesList.size();
    }
    
    public final MDEDimValueSet get(final int index) {
        return this.dimValuesList.get(index);
    }
    
    public final void clear() {
        this.dimValuesList.clear();
    }
    
    public void add(final MDEDimValueSet dimValues) {
        if (this.indexOf(dimValues) < 0) {
            this.dimValuesList.add(dimValues.clone());
        }
    }
    
    public final boolean contains(final MDEDimValueSet dimValues) {
        return this.indexOf(dimValues) >= 0;
    }
    
    public final int indexOf(final MDEDimValueSet dimValues) {
        for (int i = 0; i < this.dimValuesList.size(); ++i) {
            final MDEDimValueSet dvs = this.dimValuesList.get(i);
            if (dimValues.equals(dvs)) {
                return i;
            }
        }
        return -1;
    }
    
    public final MDEDimValueSet remove(final int index) {
        return this.dimValuesList.remove(index);
    }
    
    public final void include(final MDEDimValueSet dimValues) {
        for (int i = 0; i < this.dimValuesList.size(); ++i) {
            final MDEDimValueSet dvs = this.dimValuesList.get(i);
            if (dvs.equals(dimValues)) {
                return;
            }
            if (dvs.matches(dimValues)) {
                this.dimValuesList.set(i, dimValues.clone());
                return;
            }
        }
        this.dimValuesList.add(dimValues.clone());
    }
    
    public final void exclude(final MDEDimValueSet dimValues) throws MDEException {
        final int index = this.indexOf(dimValues);
        if (index >= 0) {
            this.dimValuesList.remove(index);
        }
        else {
            for (int i = 0; i < this.dimValuesList.size(); ++i) {
                final MDEDimValueSet dvs = this.dimValuesList.get(i);
                if (dimValues.matches(dvs)) {
                    throw new MDEException("不能部分删除维度值集");
                }
            }
            for (int i = this.dimValuesList.size() - 1; i >= 0; --i) {
                final MDEDimValueSet dvs = this.dimValuesList.get(i);
                if (dvs.matches(dimValues)) {
                    this.dimValuesList.remove(i);
                    break;
                }
            }
        }
    }
    
    public final boolean isIncluded(final MDEDimValueSet dimValues) {
        for (int i = 0; i < this.dimValuesList.size(); ++i) {
            final MDEDimValueSet dvs = this.dimValuesList.get(i);
            if (dimValues.matches(dvs)) {
                return true;
            }
        }
        return false;
    }
    
    public static void main(final String[] args) throws Exception {
        final Object[] ad1 = { null, new String("abc"), null };
        System.out.println(ad1.hashCode());
        ad1[2] = new Integer(3);
        System.out.println(ad1.hashCode());
        final Object[] ad2 = { null, new String("abc"), null };
        System.out.println(ad2.hashCode());
        ad2[2] = new Integer(3);
        System.out.println(ad2.hashCode());
        System.out.println(ad1.equals(ad2));
    }
}
